.o_web_studio_sidebar {
    display: flex;
    flex-flow: column nowrap;
    color: white;
    background-color:#0e0e0ff2;
    border-right: 3px solid $o-web-studio-bg-dark;

    .o_web_studio_sidebar_header {
        display: flex;
        flex: 0 0 auto;
        margin-bottom: $o-web-studio-sidebar-margin;
        background-color: $o-web-studio-bg-dark;

        > div {
            flex: 1 0 auto;
            text-align: center;
            padding: 14px 0;
            color: $o-web-studio-bg-light;
            background-color: $o-web-studio-bg-dark;
            box-shadow: inset 1px 0 0 $o-web-studio-bg-medium;
            cursor: pointer;

            &.inactive {
                color: rgba(192, 188, 188, 0.795);
                cursor: not-allowed;
            }
            &.active, &:first-child:last-child {
                cursor: default;
                background-color: $o-web-studio-bg-medium;
            }
            &:not(.inactive):not(.active):hover {
                color: white;
                background-color: rgba($o-web-studio-bg-medium, 0.5);
            }

            > i {
                margin-right: 4px;
            }
        }
    }

    .o_web_studio_sidebar_content {
        padding: 0 $o-web-studio-sidebar-margin $o-web-studio-sidebar-margin;

        > :first-child {
            margin-top: 0;
        }

        > h3 {
            color: white;
            margin: 10px 0 15px 0;
            cursor: default;
            &.o_web_studio_existing_fields_header {
                cursor: pointer;
            }
        }

        > hr {
            border-color: $o-web-studio-bg-dark;
            border-width: 1px;
        }

        .o_studio_sidebar_approval_rule {
            position: relative;
            &::before {
                border-left: 1px solid #6b6a6a;
                content: "";
                position: absolute;
                top: 0;
                left: -8px;
                width: 1px;
                background-color: #6b6a6a;
                height: 100%;
            }
            .inactive {
                color: grey !important; // fucking bootstrap
            }
        }

        > div,
        .o_studio_sidebar_approval_rule > div,
        > div > .card > .card-collapse > .card-body > div
         {
            margin-top: 12px;

            // Generic style for all field types
            label {
                font-size: 12px;
                font-weight: normal;
                margin: 4px 0 3px 2px;
                color: $o-web-studio-text-inactive;
            }

            input, select, textarea, div.input-group-addon {
                color: $o-web-studio-text-inactive;
                border: 1px solid transparent;
                background-color: $o-web-studio-bg-dark;
                padding: 4px 9px;
                transition: all 0.3s ease 0s;
                transition-property: background, border;
                &:focus {
                    border-color: $o-web-studio-color-info;
                    box-shadow: 0 0 1px 0 $o-web-studio-color-info;
                    color: white;
                }
                > option {
                    background-color: white;
                    color: $o-web-studio-text-dark;
                }
            }

            .input-group > input {
                min-width: 75px;
            }

            .o_web_studio_attrs {
                font-size: 11px;
                float: right;
                @include o-web-studio-sidebar-btn-link;
            }

            > button {
                @include o-web-studio-btn;
            }

            // Specific style for each field type
            &.o_web_studio_sidebar_iscode {
                input, textarea {
                    font-family: $o-web-studio-font-family-monospace;
                    font-size: 11px;
                }
                textarea {
                    white-space: pre;
                    overflow-x: scroll;
                    resize: vertical;
                }
            }

            &.o_web_studio_sidebar_checkbox {
                @include o-web-studio-checkbox;
                & + .o_web_studio_sidebar_checkbox {
                    margin-top: 2px;
                }
            }

            &.o_web_studio_sidebar_select {
                @include o-web-studio-select;
            }

            &.o_web_studio_sidebar_optional_select {
                @include o-web-studio-select;
                margin-top: 0px;
            }

            /* field in the sidebar: M2M_tags for group visibility
            and M2O for approval rules; these styles cover only these
            specific use case */
            .o_field_widget {
                display: flex;
                flex-flow: row wrap;
                flex-grow: 1;
            }
            .o_field_many2one {
                .o_input_dropdown {
                    width: auto;
                    > .o_dropdown_button {
                        right: 18px;
                        top: -2px;
                        font-size: 10px;
                        font-family: 'FontAwesome';
                        color: $o-web-studio-text-inactive;
                        &:after {
                            border: none;
                            content: "\f078"
                        }
                    }
                    &:hover .o_dropdown_button {
                        color: $o-web-studio-text-light;
                    }
                }
                .o_external_button {
                    border: 0;
                    padding-right: 0;
                    background-color: transparent;
                    &:hover, &:focus, &:active {
                        color: $o-web-studio-text-light;
                    }
                }
            }

            .o_approval_group {
                display: flex;
                & > button {
                    @include o-web-studio-btn;
                }
            }

            &.o_web_studio_sidebar_tags {
                .badge {
                    display: flex;
                    align-items: baseline;
                    max-width: $o-web-studio-sidebar-width - 2*$o-web-studio-sidebar-margin;
                    margin: 5px 5px 5px 0px;
                    cursor: default;
                    .o_badge_text {
                        margin-right: 5px;
                        @include o-text-overflow;
                        font-weight: normal;
                    }
                    .o_delete:hover {
                        cursor: pointer;
                        color: $o-web-studio-color-danger;
                    }
                    &.o_tag_color_10 {
                        background-color: $o-web-studio-color-info;
                    }
                    & + .badge {
                        margin-top: 1px
                    }
                }
            }
        }
        .o_web_studio_field_type_container {
            display: flex;
            flex-flow: row wrap;
            justify-content: space-between;
        }
        .o_web_studio_component {
            @include o-text-overflow;
            @include size(49%, 32px);
            position: relative;
            margin-bottom: 5px;
            padding: 3px 5px 0 0;
            max-width: 130px;
            border-radius: 2px;
            background-color: $o-web-studio-bg-light;
            box-shadow: 0 1px 1px black;
            color: $o-web-studio-bg-dark;
            font: bold 11px/2.4 $font-family-base;
            cursor: pointer;
            &:hover {
                background-color: white;
                &:before {
                    background: $o-web-studio-bg-light;
                }
            }
            &.o_web_studio_debug:not(.ui-draggable-helper) {
                height: 40px;
                line-height: 1.9;
            }
            .o_web_studio_component_description {
                @include o-text-overflow(block);
                padding: 2px;
                background: white;
                font: bold 10px/1 $o-web-studio-font-family-monospace;
            }
            &:before {
                @include size(33px, 150%);
                display: block;
                float: left;
                margin: -3px 5px 0 0;
                border-right: 1px solid lighten($o-web-studio-bg-dark, 50%);
                background-color: darken($o-web-studio-bg-light, 5%);
                content: "";
            }
            &:after {
                @include o-position-absolute(6px, auto, auto , 7px);
            }
        }
        .o_web_studio_existing_fields_section > h6 {
            cursor: default;
        }
        .o_web_studio_existing_fields {
            margin-top: inherit;
            .o_web_studio_component {
                @include size(100%, 32px);
                max-width: $o-web-studio-sidebar-width;
            }
        }
        .o_web_studio_sidebar_toolbox {
            flex: 1 0 100%;

            button.btn {
                @include o-web-studio-btn;
                flex: 1 1 auto;
            }

            > div {
                display: flex;
                align-content: space-between;
            }

            .o_web_studio_restore {
                margin-top: inherit;
                width: 100%;
            }

            .o_web_studio_remove_warning_groups {
                color: orange;
                display: block;
            }
        }
        .o_field_selector_chain_part {
            background: none;
        }
        .o_web_studio_edit_selection_values {
            @include o-web-studio-sidebar-btn-link;
        }

        .o_web_studio_sidebar_btn_link {
            @include o-web-studio-sidebar-btn-link;
        }
    }
}
